# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from four_wheel_steering_msgs/FourWheelSteering.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class FourWheelSteering(genpy.Message):
  _md5sum = "04dd0f55e1f168668af1e2587a7cdd2a"
  _type = "four_wheel_steering_msgs/FourWheelSteering"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """## Driving command or odometry msg for a FourWheelSteering vehicle.
#  $Id$

# Assumes FourWheelSteering with front-wheel and rear-wheel steering. The left
# and right front wheels are generally at different angles. To simplify,
# the commanded angle corresponds to the yaw of a virtual wheel located at the
# center of the front or rear axle, like on a tricycle.  Positive yaw is to
# the left. (This is *not* the angle of the steering wheel inside the
# passenger compartment.)
#
# Zero steering angle velocity means change the steering angle as
# quickly as possible. Positive velocity indicates an absolute
# rate of change either left or right.
#
float32 front_steering_angle           # position of the virtual angle (radians)
float32 rear_steering_angle            # position of the virtual angle (radians)
float32 front_steering_angle_velocity  # rate of change (radians/s)
float32 rear_steering_angle_velocity   # rate of change (radians/s)

# Speed, acceleration and jerk (the 1st, 2nd and 3rd
# derivatives of position). All are measured at the vehicle's
# center of the rear axle.
#
# Speed is the scalar magnitude of the velocity vector.
# The speed value is the norm of the velocity component in x (longitudinal) 
# and y (lateral) direction
# Direction is forward unless the sign is negative, indicating reverse.
# If the steering angle are equal to +/- pi/2, then the direction is left
# unless the sign is negative, indicating right.
#
# Zero acceleration means change speed as quickly as
# possible. Positive acceleration indicates an absolute
# magnitude; that includes deceleration.
#
# Zero jerk means change acceleration as quickly as possible. Positive
# jerk indicates an absolute rate of acceleration change in
# either direction (increasing or decreasing).
#
float32 speed                   # forward speed (m/s)
float32 acceleration            # acceleration (m/s^2)
float32 jerk                    # jerk (m/s^3)
"""
  __slots__ = ['front_steering_angle','rear_steering_angle','front_steering_angle_velocity','rear_steering_angle_velocity','speed','acceleration','jerk']
  _slot_types = ['float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       front_steering_angle,rear_steering_angle,front_steering_angle_velocity,rear_steering_angle_velocity,speed,acceleration,jerk

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(FourWheelSteering, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.front_steering_angle is None:
        self.front_steering_angle = 0.
      if self.rear_steering_angle is None:
        self.rear_steering_angle = 0.
      if self.front_steering_angle_velocity is None:
        self.front_steering_angle_velocity = 0.
      if self.rear_steering_angle_velocity is None:
        self.rear_steering_angle_velocity = 0.
      if self.speed is None:
        self.speed = 0.
      if self.acceleration is None:
        self.acceleration = 0.
      if self.jerk is None:
        self.jerk = 0.
    else:
      self.front_steering_angle = 0.
      self.rear_steering_angle = 0.
      self.front_steering_angle_velocity = 0.
      self.rear_steering_angle_velocity = 0.
      self.speed = 0.
      self.acceleration = 0.
      self.jerk = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_7f().pack(_x.front_steering_angle, _x.rear_steering_angle, _x.front_steering_angle_velocity, _x.rear_steering_angle_velocity, _x.speed, _x.acceleration, _x.jerk))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 28
      (_x.front_steering_angle, _x.rear_steering_angle, _x.front_steering_angle_velocity, _x.rear_steering_angle_velocity, _x.speed, _x.acceleration, _x.jerk,) = _get_struct_7f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_7f().pack(_x.front_steering_angle, _x.rear_steering_angle, _x.front_steering_angle_velocity, _x.rear_steering_angle_velocity, _x.speed, _x.acceleration, _x.jerk))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 28
      (_x.front_steering_angle, _x.rear_steering_angle, _x.front_steering_angle_velocity, _x.rear_steering_angle_velocity, _x.speed, _x.acceleration, _x.jerk,) = _get_struct_7f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7f = None
def _get_struct_7f():
    global _struct_7f
    if _struct_7f is None:
        _struct_7f = struct.Struct("<7f")
    return _struct_7f
